def astar(graph,h,start,goal):
    #Initialise
    infinity = float("inf")
    g = {}
    f = {}
    previous_vertex = {}
    optimal_path = []

    #Set the g and f for all vertices to infinity
    for vertex in graph:
        g[vertex] = infinity
        f[vertex] = infinity
    #Set the g and f from the start vertex to 0
    g[start] = 0
    f[start] = 0
   
    #Consider each vertex
    while graph:
        #Find the vertex with the shortest f from the start
        shortest = None
        for vertex in graph:
            if shortest == None:
                shortest = vertex
            elif f[vertex] < f[shortest]:
                shortest = vertex

        #Calculate g & f value for each node
        for neighbour, cost in graph[shortest].items():
            #Update f value and previous vertex if lower
            if neighbour in graph and cost + g[shortest] + h[neighbour] < f[neighbour]:
                g[neighbour] = cost + g[shortest]
                f[neighbour] = cost + g[shortest] + h[neighbour]
                previous_vertex[neighbour] = shortest

        #The vertex has now been visited, remove it from the vertices to consider
        graph.pop(shortest)

    #Generate the shortest shortest_path
    #Start from the goal, adding vertices to the front of the list
    vertex = goal
    while vertex != start:
        optimal_path.insert(0,vertex)
        vertex = previous_vertex[vertex]
    #Add the start vertex
    optimal_path.insert(0,start)
    
    #Return the shortest shortest_path
    return optimal_path

#Main program starts here
graph = {"A":{"B":4,"C":3,"D":2},"B":{"A":4,"E":4},"C":{"A":3,"D":1},"D":{"A":2,"C":1,"F":2},"E":{"B":4,"G":2},"F":{"D":2,"G":5},"G":{"E":2,"F":5}}
h = {"A":12,"B":6,"C":9,"D":12,"E":3,"F":9,"G":0}
print(astar(graph, h, "A", "G"))
