def calculate_hash(item, table_size):
    #Simple hashing algorithm adds ascii values of characters
    total = 0
    for character in range(len(item)):
        total = total + ord(item[character])
    return total % table_size


def create_hash_table(items, table_size):
    #Reserve memory for hashing table
    hash_table = []
    for counter in range(table_size):
            hash_table.append("")

    #Place data into hashing table
    for index in range(len(items)):
        h = calculate_hash(items[index],table_size)
        if hash_table[h] != "":
            print("Collision inserting",items[index],"at",h)
            #On collision insert in next available space
            while hash_table[h] != "":
                h = h + 1
        hash_table[h] = items[index]
        print("Inserted",items[index],"at position",h)
    return hash_table

def search_hash_table(item_to_find, hash_table):
    found = False
    h = calculate_hash(item_to_find, len(hash_table))
    #Attempt to find item at hash value
    if hash_table[h] != "":
        if hash_table[h] == item_to_find:
            found = True
        else:
            #Degrade to linear search for collisions
            while h<len(hash_table) and not found:
                if hash_table[h] != item_to_find:
                    h = h + 1
                else:
                    found = True
    if found:
        print ("Item found at position",h)
    else:
        print("Item not found")

#Main algorithm starts here
items = ["Florida","Georgia","Delaware","Alabama","California"]
#The larger the table the fewer collisions
table_size = 10
hash_table = create_hash_table(items, table_size)
item_to_find = input("Enter the state to find: ")
search_hash_table(item_to_find, hash_table)
